# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/)
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

Generated by [`auto-changelog`](https://github.com/CookPete/auto-changelog).

## [v1.3.1](https://github.com/ljharb/html-element-map/compare/v1.3.0...v1.3.1) - 2021-05-19

### Commits

- [readme] add badges and examples [`e0e01f1`](https://github.com/ljharb/html-element-map/commit/e0e01f12410d817c167b24cec90160f3c7446907)
- [actions] use `node/install` instead of `node/run`; use `codecov` action [`e28233f`](https://github.com/ljharb/html-element-map/commit/e28233f18dd0d93bd6f3042661a47416c8b70e35)
- [Dev Deps] update `eslint`, `@ljharb/eslint-config`, `aud`, `function.prototype.name`, `object-inspect`, `tape` [`e0ae318`](https://github.com/ljharb/html-element-map/commit/e0ae3186d74f0e7b9ed990402ae46dafb155b2de)
- [Refactor] use `array.prototype.filter` instead of `array-filter` [`fda63b9`](https://github.com/ljharb/html-element-map/commit/fda63b98f7892f0979c3b6e32d2db2029055158c)
- [Dev Deps] update `eslint`, `object-inspect` [`8a542b2`](https://github.com/ljharb/html-element-map/commit/8a542b227bc3482465dcb5e9a321017f0bf42d2c)
- [meta] use `prepublishOnly` script for npm 7+ [`f5ab052`](https://github.com/ljharb/html-element-map/commit/f5ab052de742ced3ad56c3e849507566c5988505)

## [v1.3.0](https://github.com/ljharb/html-element-map/compare/v1.2.0...v1.3.0) - 2021-01-23

### Commits

- [Tests] migrate tests to Github Actions [`1a0cce5`](https://github.com/ljharb/html-element-map/commit/1a0cce57a30cbb8b586361418027d9ba69c5a884)
- [New] add ESM wrappers [`7b158ed`](https://github.com/ljharb/html-element-map/commit/7b158ed435d4ba897cc31ea266abcd913e1968d5)
- [meta] do not publish github action workflow files [`2e8ad37`](https://github.com/ljharb/html-element-map/commit/2e8ad378f75592346e94725b1927de7afaec2552)
- [meta] add "exports" field [`89ae540`](https://github.com/ljharb/html-element-map/commit/89ae54009fcb7c025156d0bf3d3eace0cc827e8e)
- [Tests] run `nyc` on all tests; use `tape` runner [`1158f19`](https://github.com/ljharb/html-element-map/commit/1158f1952605c5652a9c7ea143b2c2d4f111c897)
- [Dev Deps] update `eslint`, `@ljharb/eslint-config`, `aud`, `auto-changelog`, `function.prototype.name`, `object-inspecft`, `tape` [`f1c295b`](https://github.com/ljharb/html-element-map/commit/f1c295ba138c6114b5b8b10867db6affddb4d01c)
- [actions] add "Allow Edits" workflow [`ab4c8ab`](https://github.com/ljharb/html-element-map/commit/ab4c8ab4ec9164cdf5d31359c33bea1999eaeeae)
- [Robustness] use `call-bind` [`ad4ef75`](https://github.com/ljharb/html-element-map/commit/ad4ef75621c2dbc7b70966775cfda2f3fce04458)
- [Dev Deps] update `eslint`, `@ljharb/eslint-config`, `tape`, `function.prototype.name` [`5dc88aa`](https://github.com/ljharb/html-element-map/commit/5dc88aa8c3b51c2f7b614001e5b0630a926b5cda)
- [Dev Deps] update `@ljharb/eslint-config`, `tape`; add `safe-publish-latest` [`5b3a1a6`](https://github.com/ljharb/html-element-map/commit/5b3a1a6a3789c8f6d5efc3122f8ee732bc85d9a3)
- [actions] switch Automatic Rebase workflow to `pull_request_target` event [`7837752`](https://github.com/ljharb/html-element-map/commit/7837752ec4189c8f1ac89e0dac8df449dc29312c)
- [Dev Deps] update `auto-changelog`, `tape` [`09a7de6`](https://github.com/ljharb/html-element-map/commit/09a7de6a99d9bd49e345a24c7f040ab2f58b5c14)
- [Dev Deps] update `auto-changelog`; add `aud` [`124eefd`](https://github.com/ljharb/html-element-map/commit/124eefdfcfffa248a8fe590c002a8fc03fcfb8fe)
- [Tests] only audit prod deps [`b57ddb4`](https://github.com/ljharb/html-element-map/commit/b57ddb419c0766cebb3395129d471221e24b4bc7)

## [v1.2.0](https://github.com/ljharb/html-element-map/compare/v1.1.0...v1.2.0) - 2019-11-19

### Commits

- [New] add missing elements: [`5b3afd9`](https://github.com/ljharb/html-element-map/commit/5b3afd94afaf706879e11ce7da4b627b53f2b2f4)
- [Tests] use shared travis-ci configs [`bceebe1`](https://github.com/ljharb/html-element-map/commit/bceebe130e3fab955e6345f6115a272711f5499f)
- [actions] add automatic rebasing / merge commit blocking [`2219cb7`](https://github.com/ljharb/html-element-map/commit/2219cb7ca869dfdf13a1ab54dae96c3efb7d6ed1)
- [meta] add `auto-changelog` [`377cc9a`](https://github.com/ljharb/html-element-map/commit/377cc9a762fe3e4205168301c24a399a183daea3)
- [meta] create FUNDING.yml [`c1e8765`](https://github.com/ljharb/html-element-map/commit/c1e87653fc5acadc56698afa38475749e95a9e3f)
- [Dev Deps] update `eslint`, `@ljharb/eslint-config`, `object-inspect`, `function.prototype.name` [`645d278`](https://github.com/ljharb/html-element-map/commit/645d278d6cc7b52d1c721f7bc6bdd84a287e51d6)
- [meta] add `funding` field [`9b75c6e`](https://github.com/ljharb/html-element-map/commit/9b75c6e641830d0edec23e32122ff4415f2dd01d)

## [v1.1.0](https://github.com/ljharb/html-element-map/compare/v1.0.1...v1.1.0) - 2019-07-18

### Commits

- [Dev Deps] update `eslint`, `isarray`, `tape` [`9a84437`](https://github.com/ljharb/html-element-map/commit/9a844371a81ccb6f6e687c9de9ad24603c9b9369)
- [New] add support for `main` tag [`b4126b6`](https://github.com/ljharb/html-element-map/commit/b4126b66caa26d1b644cc1acc41b9c10572d350d)

## [v1.0.1](https://github.com/ljharb/html-element-map/compare/v1.0.0...v1.0.1) - 2019-03-27

### Fixed

- [Fix] remove `applet` - it does not exist in modern browsers, and in older ones, it pops up a Java dialog [`#3`](https://github.com/ljharb/html-element-map/issues/3)

### Commits

- [Tests] use `npx aud` instead of `npm audit` with hoops [`6b50fe0`](https://github.com/ljharb/html-element-map/commit/6b50fe04ca6d8f25ea014f5723cdb60a8ba2f44c)
- Remove unused variables [`a9405d1`](https://github.com/ljharb/html-element-map/commit/a9405d1254803a01a6bedf6cd9502653df9db8c9)

## v1.0.0 - 2019-01-27

### Commits

- Implementation and tests. [`89ed6e8`](https://github.com/ljharb/html-element-map/commit/89ed6e8f999958d55a1436df09682401f796074a)
- Initial commit [`a96566c`](https://github.com/ljharb/html-element-map/commit/a96566ce0af96c65f54ba505b96ed162de0a6ab8)
- package.json [`13bef99`](https://github.com/ljharb/html-element-map/commit/13bef99dad73526019e666c7e213d67dcc9cf629)
- byConstructor: no need to throw when passed the wrong kind of thing [`d0944d1`](https://github.com/ljharb/html-element-map/commit/d0944d1ef92feee9377dc4c42669c431cd3c1bea)
- [Tests] add `npm run lint` [`c3d3a8b`](https://github.com/ljharb/html-element-map/commit/c3d3a8b0c8bc61494b7a0b774d51054cce969749)
- [Tests] add `npm run audit` in `posttest` [`1217bd8`](https://github.com/ljharb/html-element-map/commit/1217bd898bcc050b80a870ff31ac61a3643919a4)
- Only apps should have lockfiles [`1d41375`](https://github.com/ljharb/html-element-map/commit/1d413752ccf5ebb2d4e6d37e548118a86c98eda4)
